/*  sn.h  by K.Tsuru  */
/***********************************************
 Include header files for SNumber classes
***********************************************/
#ifndef SN_H
#define SN_H
/**************
compile swithes
***************/
//#define NDEBUG
//#define PoorMemory 1
/****************************************************************************
Preprocessors UseFFT and NotUseFFT are removed since version 2.20 i.e. FFT
multiplication is used if needs.
****************************************************************************/
#define _CRT_SECURE_NO_WARNINGS	// for visual c++ since ver 2.19
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <limits.h>
#include <new>
#include <math.h>	// added since 2.30
#include <cmath>	// <math.h> is included in "gcc"
#include <string>
#include <complex>
#include <iostream>	// added since ver 2.182
#include <iomanip>	// since ver.2.21
#include <ostream>	// added since ver. 2.3
#include <fstream>	// added since ver. 2.3
#include <sstream> // since ver.2.31
#include <algorithm>	// added since ver 2.91 for max(). min()

using namespace std;	// ver. 2.17

#ifndef __cplusplus
#error Use C++ compiler.
#endif  // __cplusplus

//It detects that used system is 16 bits or not.
#if INT_MAX == SHRT_MAX
#error This library is for 32 bits system. Please use Turbo C++ version(16 bits).
#endif	// INT_MAX == SHRT_MAX

//Definition of Mathematical constants M_E, M_PI, etc.
#ifndef  DEF_CONST_H
#include "defconst.h"
#endif	//DEF_CONST_H

// Mathmatical template functions are defined.
#ifndef MATH_TEMPLATE_H
#include "mathtp.h"
#endif  // MATH_TEMPLATE_H

#ifndef TOOLS_H  // ver. 2.17
#include "tools.h"
#endif  // TOOLS_H

// FFT

#ifndef S_FFT_H
#include "sfft.h"
#endif  // S_FFT_H

// typedef and contants are defined
#ifndef SN_CONST_H
#include "snconst.h"
#endif  // SN_CONST_H

// NCBlock template class
#ifndef NC_BLOCK_H
#include "ncblock.h"
#endif  // NC_BLOCK_H

// SNBlock template class
#ifndef SNBLOCK_H
#include "snblock.h"
#endif

// SNStack template class
#ifndef SNSTACK_H
#include "snstack.h"
#endif 	// STACK_H

#ifndef SNMANAGER_H	// SNManager class
#include "snmanage.h"
#endif

#ifndef S_NUMBER_H	// SNumber class
#include "snum.h"
#endif

#ifndef S_LONG_H	// SLong class
#include "slong.h"
#endif

#ifndef S_REAL_H	// RealSize class and SCalcInfo structure
#include "sreal.h"
#endif 	// S_REAL_H


#ifndef S_DOUBLE_H	// SDouble class in decimal radix
#include "sdbl.h"
#endif

#ifndef STRING_NUMBER_H // StringToNumber class
#include "sstr.h"
#endif

#ifndef S_DECIMAL_H	// SDecimal class in binary radix
#include "sdec.h"
#endif

#ifndef SN_INLINE_H  // SNumber inline functions
#include "sninline.h"
#endif

#ifndef S_DEC_INT_H	// SInteger class in binary radix
#include "sint.h"
#endif

#ifndef S_FRACTION_H // SFraction class by use of SLong
#include "sfract.h"
#endif

#ifndef S_RATIONAL_H // SRational class by use of SInteger
#include "sratio.h"
#endif

#ifndef SN_FUNCTIONS_H	// prototype of various mathematical functions
#include "snfunc.h"
#endif

#ifndef SN_MATH_H	// fundamental mathematical functions
#include "snmath.h"
#endif

#ifndef SNC_FILE_H
#include "sncfile.h"	// for three constant files
#endif

#ifndef  SCOMPLEX_H
#include "scomplex.h"	// SComplex class by use of SDouble
#endif

#ifndef  SLCOMPLEX_H
#include "slcomplx.h"	// SLComplex class by use of SLong, since ver. 2.18
#endif

// template class of binary splitting method,  since ver. 2.17
#ifndef BINARY_SPLITTING_TEMPLATE_H
#include "sbstempl.h"
#endif

// template class of square coupling method,  since ver. 2.18
#ifndef SQUARE_COUPLING_TEMPLATE_H
#include "ssqcoupl.h"
#endif

#ifndef SQUARE_COUPLING_INV_TEMPLATE_H
#include "ssqcpinv.h"
#endif

#ifndef SN_EXTERN_H
#include "SNextern.h" // since version 2.20
#endif
// related to keybord and time measurement added since ver 2.182

#ifndef GET_NUMBER_H
#include "getnum.h"
#endif

#ifndef WAIT_H
#include "wait.h"
#endif

#ifndef TIMER_H
#include "timer.h"
#endif

#endif 	// SN_H
