/*  smplong.cpp  by K.Tsuru  */
static const char* title =
"<<<<<<< A sample program for SLong. >>>>>>>>";
#include "sn.h"
#include "getnum.h"
#include "wait.h"
void Pow4Number(){
/*
[Reference]
Shin Hitomatsu "Suugaku to conpyu-ta"(Mathematics and computer) p.26
(Kyouritsu shuppan, 1995)
original
	a=2682440, b=15365639, c=18796760,d=20615073
These give a non-zero value a^4+b^4+c^4-d^4=2 10273 64006 72474 43282 80800.
There is a mistake in the value of d.
*/
	cerr << "---- Four integral numbers which satisfy a^4 + b^4 + c^4 = d^4 ----" << endl;
	SLong a("2682440"), b("15365639"), c("18796760"),d("20615673"), r;
	SLong ap4 = Lpow(a, 4),	bp4 = Lpow(b, 4), cp4 = Lpow(c, 4), dp4 = Lpow(d, 4);
	r = ap4 + bp4 + cp4 - dp4;
	cout << a << "^4 + " << b << "^4 + " << c << "^4 - " << d << "^4 = " << r << endl;

	cerr << "Did you get zero on rhs?" << endl << endl << "Fourth power values are shown below." << endl;
	cout << a << "^4= " << ap4 << endl;
	cout << b << "^4= " << bp4 << endl;
	cout << c << "^4= " << cp4 << endl;
	cout << d << "^4= " << dp4 << endl;
	Wait();
}
void GCDandLCM() {
	cout << "---- Test of GCD and LCM -----" << endl;
	SLong a = LRand(5), b = LRand(8), c = LRand(6), m, n;

	m = a * b;	n = b * c;
	SLong gcd = gcdL(m, n), lcm = lcmL(m, n), abc = a*b*c;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl;
	cout <<"m = a * b = " << m << endl;
	cout <<"n = b * c = " << n << endl;
	cout <<"gcd(m, n) = " << gcd << endl;
	cout <<"lcm(m, n) = " << lcm << endl;
	cout <<"a*b*c = \n" << abc << endl;
}

void PowerTable(int n, int maxN){
	SLong x(1), a(n);
	cout <<"***** power of "<< n << " ******" << endl;
	for(int i = 1; i <= maxN; i++) {
		x *= a;
		cout << n << "^" << i << " = " << x << endl;
	}
}
int main()
{
	SLong x;
	x.Version();
	cerr << title << endl;
	x.SetFormat(0); // common format

	GCDandLCM();
	Wait();

	int Max = 50, i;

	Pow4Number();
	PowerTable(1024, 20);
	Wait();

	cout << "***** Table of factorial ******" << endl;
	x=1;
	for(i=1; i<=Max; i++){
		x *= i;
		cout << i << "!= " << x << endl;
	}
	Wait();

	cout << "***** Table of (2n+1)!! *******" << endl;
	x=1;
	for(i=1; i<=2*Max+1; i += 2){
		x *= i;
		cout << i << "!!= " << x << endl;
	}
	Wait();

	puts("***** Table of (2n)!! *******");
	x=1;
	for(i=2; i<=2*Max; i += 2){
		x *= i;
		cout << i << "!!= " << x << endl;
	}
	Ending();
}
