/*  smppicmp.cpp  by K.Tsuru  */
#include "sn.h"
const char* const title = "Speed test of some functions calculating pi.";
void ShowFname(const char* fname){
	cout << "****************** " << fname << " ********************" << endl;
}

SDouble ConstFuncSpeed(SDouble (*sdfunc)(), const char* fname) {
	Timer timer;
	SDouble r;
	ShowFname(fname);

	timer.Start();
	r = (*sdfunc)();
	double time = timer.Stop();

	cout << fname << " CPU time = " << time << "(sec) " << r.DFigures() << "(figures)"<< endl;

	return r;
}
void PiFuncCompare() {
	cerr << "Effective figures/4 =? ";
	int fig = GetInt();
	if(fig <= 0) return;

	RealSize C;
	C.SetEffFig(fig);
// pi by Borweins' method improved by by Takahashi and Kanada is fastest.
	ConstFuncSpeed(AGMPi, "AGMPi");
	ConstFuncSpeed(BorweinsPi, "BorweinsPi");
	ConstFuncSpeed(ChudnovskysPi, "ChudnovskysPi");
	ConstFuncSpeed(RamanujanPi, "RamanujanPi");
	ConstFuncSpeed(SNPi, "SNPi(same as ChudnovskysPi)");
//	ConstFuncSpeed(KlingenstiernaPi, "KlingenstiernaPi"); very slow

}
int main() {
	cout << title << endl;
	PiFuncCompare();
	Ending();
}
