/*  scfcpowd.cpp  by K.Tsuru  */
// function ID = 9104
/********************************
SComplex class
It returns z^a = exp(a*log(z)).
*********************************/
#ifndef SN_H
#include "sn.h"
#endif
SComplex Cpow(const SComplex& z, const SDouble& a){
	if( z.IsZero(9104) ) SNManager::SetError(SNManager::DOMAIN_ERR, "Cpow", 9104);// z == 0
	if( a.Sign(9104) == 0 ) return 1.0;	// a == 0
	SComplex b;
	b = Clog(z);
	b *= a;
	return Cexp(b);
}
