/*  sdfqrrt.cpp  by K.Tsuru  */
// function ID = 3012  DRADIX only
/****************************
SDouble class
quartic root of a
It returns a*{RecQrrt(a)}^3.
*****************************/
#ifndef SN_H
#include "sn.h"
#endif
static const char* const func = "Qrrt";

SDouble Qrrt(const SDouble& a){
	SDouble d, y;
	y = RecQrrt(a);	// if a < 0 causes an error
	y = a*Dpow(y, 3);
	if(y.Verify()){		// check |a - y^3| << a ?
		d = y*y;	d = d*d;
		d = a - d;
		if(!d.IsMLT(a)){  //It sees the relative error. d << a ?
			y.SetError(y.VERIFY, func, 3012);
		}
	}
	return y;
}
