/*  sxfsccov.cpp  by K.Tsuru  */
// function ID = 512	BRADIX
// since ver 2.18
/************************************
BRADIX --> DRADIX
Radix conversion SDecimal to SDouble
using "square coupling" method
*************************************/
#ifndef SN_H
#include "sn.h"
#endif

/// SLong version ///
SDouble SC_ConvSDecToSDbl(const SDecimal& x) {
	const SLong R(BRADIX);
	const fType* pf = x.ReadFigures();
	long p = x.Last();
	SLong *w = new SLong[p];	// work area

	for(int i = 0; i < p; i++) w[i].SetShort(pf[i+1]);

	SquareCouplingInverseR<SLong> cv(w, R, p);
	SDouble a = cv.getA(), r = cv.getR(), result;
	result = (SDouble)a/(SDouble)r + (SDouble)pf[0];// add integer part

	delete[] w;
	return result; 
}
