/*  AsinBSTest.cpp  by K.Tsuru  */ 

#include "sn.h"

void TestAcos() {
	SDouble pi, a, x,er, diff;
	Timer timer; 
	int fig;

	while(1){
		RealSize C;
		ErrorPut("Acos(x) test. Effective figures/4 =?(<= 0 quit) ");
		fig = GetInt();
		if(fig <= 0) break;
		C.SetEffFig(fig);
		x.SetFormat(0,20);
		pi = Pi();
		x = DRand(x.EffFig()/100);
		cout << "x.Head() = " << x.Head() << endl;
		timer.Start();
		a = Acos(x);
		double tAc = timer.Stop();	
		cout << "cpu time(Acos) = " << tAc << endl;
//		cout << "a = " << a << endl;
		er = Cos(a)-x;
		cout << "Cos(a)-x = " << er << endl;
		C.SetEffFig(0);
	}
}
void TestAsin() {
	SDouble pi, a, x,er, diff;
	Timer timer; 
	int fig;

	while(1){
		RealSize C;
		ErrorPut("Asin(x) test. Effective figures/4 =?(<= 0 quit) ");
		fig = GetInt();
		if(fig <= 0) break;
		C.SetEffFig(fig);
		x.SetFormat(0,20);
		pi = Pi();
		x = DRand(x.EffFig()/100);
		cout << "x.Head() = " << x.Head() << endl;
		timer.Start();
		a = Asin(x);
		double tAs = timer.Stop();	
		cout << "cpu time(Asin) = " << tAs << endl;
//		cout << "a = " << a << endl;
		er = Sin(a)-x;
		cout << "Sin(a)-x = " << er << endl;
		C.SetEffFig(0);
	}
}
void AsinBSNWTest() {
	SDouble  pi,a, b, x,er, diff;
	Timer timer; 
	int fig;
	while(1){
		RealSize C;
		ErrorPut("Asin(x) compare with AsinBSNW(x). Effective figures/4 =?(<= 0 quit) ");
		fig = GetInt();
		if(fig <= 0) break;
		C.SetEffFig(fig);
		x.SetFormat(0,20);
		pi = Pi();
		cout << pi << endl;
		x = DRand(pi.EffFig()); //0.15;

		cout << "Asin(x) for x = " << x << endl;
		timer.Start();
		a = Asin(x);
		double tAs = timer.Stop();	
	//	cout << "Asin(x) = " << a << endl;
		cout << "cpu time(Asin) = " << tAs << endl;
	cout << "a = " << a << endl;
	er = Sin(a)-x;
		cout << "Sin(a)-x = " << er << endl;
		timer.Start();
		b = AsinBSNW(x);
		double tAsBS = timer.Stop();	
		cout << "cpu time(AsinBSNW) = " << tAsBS << endl;
	er = Sin(b)-x;
		cout << "Sin(b)-x = " << er << endl;
	
		diff = a - b;
	//	cout << "a/pi= " << (a/pi) << endl;
	//	cout << "b/pi= " << (b/pi) << endl;
		cout << "diff = " << diff << endl;
		C.SetEffFig(0);
	}
}
int main() {
	TestAcos();
	cout << "***************************" << endl;
	TestAsin();
	cout << "***************************" << endl;
	AsinBSNWTest();
}
