/*  ExpRecETest64bit.cpp  by K.Tsuru  */
#include "sn.h"

/*
Test program the base of natural logarithm e.
  E()*RecE()=1 or not.
This is also the test of maximum digits.
  
const int FFT_MAX_SIZE_BITS = 23;	// 20 --> 22 --> 23;
CPU time
100,000,000 digits
E()    296.0(sec) about 4.9(min)
RecE() 295.6(sec) nearly the same
1 - E()*RecE() = -1.0e-100000028 OK

============================================
130,000,000 digits(FFT_MAX_SIZE_BITS = 22)
E()    444.42(sec) about 7.4(min)
RecE() 439.81(sec) nearly the same
1 - E()*RecE() =  41.0 (sec)
 -1.0e-130000028 OK
=============================================
130,000,000 digits(FFT_MAX_SIZE_BITS = 23)
E()    342.483(sec) about 5.7(min)... 1.3 times faster
RecE() 342.811(sec) nearly the same
1 - E()*RecE() =  25.6 (sec)
 -1.0e-130000028 OK

=============================================
132,000,000 digits normally ended.
copy of screen of execution
------------------------------------
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 132,000,000
Computing e now in 132000000(digits).
Cpu time of E()=285.825(sec)
Computing 1/e now.
Cpu time of RecE()=285.461(sec)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 25.7535(sec)
0.0 <== close to 0.0 ?
=============================================
132,000,000 digits(FFT_MAX_SIZE_BITS = 22) again 2017/03/19
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 132,000,000
Computing e now in 132000000(digits).
Cpu time of E()=459.523(sec)
Computing 1/e now.
Cpu time of RecE()=458.32(sec)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 41.8729(sec)
0.0 <== close to 0.0 ?
=============================================
132,000,000 digits(FFT_MAX_SIZE_BITS = 23) again 2017/03/19
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 132,000,000
Computing e now in 132000000(digits).
Cpu time of E()=355.502(sec)
Computing 1/e now.
Cpu time of RecE()=354.356(sec)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 25.7738(sec)
0.0 <== close to 0.0 ?
=============================================
64bit version 2017/03/30
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 132,000,000
Computing e now in 132000000(digits).
Cpu time of E()=570.32(sec)
Computing 1/e now.
Cpu time of RecE()=564.14(sec)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 22.3332(sec)
0.0 <== close to 0.0 ?
SN Library Version 2.30 by K.Tsuru / GNU Library General Public License Version 2.
<<< SNumber information >>>
SNObjects() = 591
radix = 10000 / 32768
Verify is OFF.
------- Size information ------------
maxSizeOfMemoryBlock = 1073741824(bytes), maxArraySize = 536870912, minArraySize = 4
defaultEffFig = 61
----- Real number information -----
EffFigures() = 61, Hidden() = 2
Maximum size of SDecimal = 58
Maximum value of exponent = 214748359(radix = 10000)

<<< FFT information >>>
defaultFFTMinSize = 16
fftMaxSize = 8388608(DRADIX) and 1048576(BRADIX)
MFFTMinSize() = 16,  FFTUsedTimes() = 5733537
FFTVerify is OFF.
FFTWorkSize is 25165808.
FFT used memory is 201326464(bytes).
Uses Karatsuba's multiplication = Yes
Karatsuba's multiplication used times = 154.
=========================================================================
140,000,000 digits
150,000,000 digits
Sory, out of memory!
=============================================
64bit version 2017/04/05
Computing e now in 1,000,000,000(digits).[1 billion]
Cpu time of E()=7287(sec)
Computing 1/e now.
Cpu time of RecE()=7178(sec)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 709.23(sec)
0.0 <== close to 0.0 ?
=============================================
64bit version 2017/04/10
Computing e now in 2000000000(digits).
Cpu time of E()=18198(sec) 5.055000(hour)
Computing 1/e now.
Cpu time of RecE()=18242.000000(sec)5.067222(hour)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 2073.000000(sec) 0.575833(hour)
-1.0 e-2000000028 <== close to 0.0 ?

file size 2.06GB, used memory 13GB
=============================================
64bit version + Sine table + long double 2017/08/12
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 10000 0000
Computing e now in 100000000(digits).
Cpu time of E()= 252.233(sec) 4.203887(min)
Computing 1/e now.
Cpu time of RecE()= 247.943051(sec) 4.132384(min)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 17.080318(sec) 0.284672(min)
-1.0 e-100000028 <== close to 0.0 ?
=============================
<<< FFT information >>>
defaultFFTMinSize = 16
fftMaxSize = 134217728(DRADIX) and 16777216(BRADIX)
MFFTMinSize() = 16,  FFTUsedTimes() = 4189775
FFTVerify is OFF.                     ^^^^^^^
FFTWorkSize is 100663322.
FFT used memory is 1610613152(bytes).
Uses FFTSineTable : Yes
Uses Karatsuba's multiplication : Yes
Karatsuba's multiplication used time
Uses "long double" in FFT : Yes
                            ^^^
SN Library Version 2.30 by K.Tsuru / GNU Library General Public License Version 2.
<<< SNumber information >>>
SNObjects() = 598
radix = 10000 / 32768
Verify is OFF.
------- Size information ------------
maxSizeOfMemoryBlock = 1073741824(bytes), maxArraySize = 536870912, minArraySize = 4
defaultEffFig = 61
----- Real number information -----
EffFigures() = 61, Hidden() = 2
Maximum size of SDecimal = 58
Maximum value of exponent = 2147483646(radix = 10000)
-=========================================================
64bit version + Sine table + double 2017/08/12
 The test of RecE()*E()=1 ? This is a test of the limit of figures.
Where RecE() and E() are independently evaluated by series using "class BinarySplitting".
How many digits do you want? (<=0 quit) = 10000 0000
Computing e now in 100000000(digits).
Cpu time of E()= 151.231(sec) 2.520518(min)
Computing 1/e now.
Cpu time of RecE()= 146.435598(sec) 2.440593(min)
Computing 1 - e*(1/e) now.
Cpu time of 1.0 - e*(1/e))= 15.428450(sec) 0.257141(min)
-1.0 e-100000028 <== close to 0.0 ?
=============================
<<< FFT information >>>
defaultFFTMinSize = 16
fftMaxSize = 8388608(DRADIX) and 1048576(BRADIX)
MFFTMinSize() = 16,  FFTUsedTimes() = 4190017
FFTVerify is OFF.
FFTWorkSize is 25165846.
FFT used memory is 201326768(bytes).
Uses FFTSineTable : Yes
Uses Karatsuba's multiplication : Yes
Karatsuba's multiplication used times = 101.
Uses "long double" in FFT : No
SN Library Version 2.30 by K.Tsuru / GNU Library General Public License Version 2.
<<< SNumber information >>>
SNObjects() = 598
radix = 10000 / 32768
Verify is OFF.
------- Size information ------------
maxSizeOfMemoryBlock = 1073741824(bytes), maxArraySize = 536870912, minArraySize = 4
defaultEffFig = 61
----- Real number information -----
EffFigures() = 61, Hidden() = 2
Maximum size of SDecimal = 58
Maximum value of exponent = 2147483646(radix = 10000)

<<< FFT information >>>
defaultFFTMinSize = 16
fftMaxSize = 8388608(DRADIX) and 1048576(BRADIX)
MFFTMinSize() = 16,  FFTUsedTimes() = 4190017
FFTVerify is OFF.
FFTWorkSize is 25165846.
FFT used memory is 201326768(bytes).
Uses FFTSineTable : Yes
Uses Karatsuba's multiplication : Yes
Karatsuba's multiplication used times = 101.
Uses "long double" in FFT : No
Would you like output the "e" result to a file "e100000029.dat" Yes(1)/No(0) ?
*/
void Exp_Mult_RecE_eq1(SDouble &e, SDouble &recE, int* f)
{
	cerr << " The test of RecE()*E()=1 ? This is a test of the limit of figures." << endl;
	cerr << "Where RecE() and E() are independently evaluated by series using \"class BinarySplitting\"." << endl;
	RealSize C;
	Timer timer;
	cerr << "How many digits do you want? (<=0 quit) = ";
	int fig = GetInt();
	if(!fig) return;
	C.SetEffFig(fig/4);
	*f =fig/4;
	SDouble x;
// e = 1 + 1/1! + 1/2! + 1/3! +...
	cerr << "Computing e now in " << fig << "(digits)." << endl;
	timer.Start();
	e = BSE();	// default method of e
	double te = timer.Stop();
	cout << "Cpu time of E()= " << te <<"(sec) "  << fixed << (te/60.0) << "(min)" << endl;
// 1/e = 1 - 1/1! + 1/2! - 1/3! +...
	cerr << "Computing 1/e now." << endl;
	timer.Start();
	recE = RecE(false);  // It evaluates by the series not 1/E(). See "snmath.h"
	double tre = timer.Stop();
	cout <<  "Cpu time of RecE()= " << tre <<"(sec) " << fixed << (tre/60.0) << "(min)"<< endl;

	cerr << "Computing 1 - e*(1/e) now." << endl;
	timer.Start();
	x=1.0 - e*recE; // e*(1/e)
	double chk = timer.Stop();
	cout <<  "Cpu time of 1.0 - e*(1/e))= " << chk <<"(sec) " << fixed << (chk/60.0) << "(min)" << endl;

	cout << x << " <== close to 0.0 ?" << endl;
	cout << "=============================" << endl;
	FFTInfo();
}

void FileOut(const SDouble& data, const string& fname, const string& title) {
	ofstream fout(fname.c_str(),ios::trunc);	 // open file

	data.SetFormat(10, 0, 10, data.INT_PUT|data.CRLF);
//	data.SetFormat(10, 0, 5, data.INT_PUT|data.CRLF|data.SHOW_FIG); // add the number of figures at line end
	fout << title << " (" << data.DFigures() << " digits)" << endl;
	fout << data << endl << " (" << data.DFigures() << " digits)" << endl;
	fout.close();
}
int main() {
	SDouble e, recE;
	int f;
	Exp_Mult_RecE_eq1(e, recE, &f);
	SNInfo();

	string sfig;
	stringstream sout;
	sout << e.DFigures();
	sfig = sout.str();

	string e_fname, recE_fname;
	e_fname ="e" + sfig + ".dat";
	recE_fname ="recE" + sfig + ".dat";
	cerr << "Would you like output the \"e\" result to a file \"" << e_fname << "\" Yes(1)/No(0) ?";
	if( !GetInt() ) return 0;

	RealSize C;
	C.SetEffFig(f);
	FileOut(e, e_fname, "e =");

	cerr << "Output \"1/e\" to a file \"" << recE_fname << "\" Yes(1)/No(0) ?";
	if( !GetInt() ) return 0;
	FileOut(recE, recE_fname, "1/e =");
}
