/* functest.cpp by K.Tsuru*/
/*
It compares SDouble functions with double ones.
*/

#include "sn.h"
#include "timer.h"
#include "getnum.h"
#include "Wait.h"

int step = 1;


void ShowTitle(const char* func){
	printf("****************** test of ");
	printf("%s", func);
	puts(" ********************");
	puts("              x               double    test of doubleD   difference");
}
void SinTest(){
	double x, y, z, p = 0.11*M_PI;
	int j;
	ShowTitle("Sin(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = sin(x);

		Y = SinRN(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void CosTest(){
	double x, y, z, p = 0.11*M_PI;
	int j;
	ShowTitle("Cos(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = cos(x);
		Y = Cos(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void BsinTest(){
	double x, y, z, p = 0.11*M_PI;
	int j;
	ShowTitle("Bsin(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = sin(x);

		Y = Bsin(x).ConvToDec();
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void BcosTest(){
	double x, y, z, p = 0.11*M_PI;
	int j;
	ShowTitle("Bcos(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = cos(x);
		Y = Bcos(x).ConvToDec();
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void TanTest(){
	int q = 10;
	double x, y, z, p = M_PI_2/q;
	int j, k;
	ShowTitle("Tan(x)");
	SDouble Y, one(1.0);
	for(j = -10; j <= 10; j++){
		k = step*j;
		x = k*p;
		if( (k%q) == 0) x *= 0.99;	// x = n*M_PI_2
		y = tan(x);
		Y = Tan(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void AsinTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Asin(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = p*j;
		if(fabs(fabs(x) - 1.0) < DBL_EPSILON*5) x *= 0.999;
		y = asin(x);
		Y = Asin(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void AcosTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Acos(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = p*j;
		if(fabs(fabs(x) - 1.0) < DBL_EPSILON*5) x *= 0.999;
		y = acos(x);
		Y = Acos(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void AtanTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Atan(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = atan(x);
		Y = Atan(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void AtanATest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("AtanT(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = step*p*j;
		y = atan(x);
		Y = AtanA(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void LogTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Log(x)");
	SDouble Y;
	for(j = 1; j <= 20; j++){
		x = p*j;
		y = log(x);
		Y = Log(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void Log10Test(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Log10(x)");
	SDouble Y;
	for(j = 1; j <= 20; j++){
		x = p*j;
		y = log10(x);
		Y = Log10(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void ExpTest(){
	double x, y, z, p = 3.7;
	int j;
	ShowTitle("Exp(x) [errors are relative ones]");
	SDouble Y, X;
	for(j = -10; j <= 10; j++){
		x = p*j;
		y = exp(x);
		X = x;
		Y = Exp(X);
		z = doubleD(Y);
		X = Y - y;
		Y = (Y - y)/Y;
		printf(" %20.15f  %20.15e %13.5e ", x, y, (z - y)/y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void ExpCompareTest(uint ef){
	double x,p = M_PI;
	RealSize C;
	C.SetEffFig(ef);
	int j;
	cout << "compare ExpDS(x) and ExpBS(x) in ef = " << ef << endl;
	cout << "   x    " << "ExpDS(x) - ExpBS(x)" << endl;
	SDouble Y, X, diff;
	for(j = -10; j <= 10; j++){
		x = p*j;
		Y = ExpDS(x);
		X = ExpBS(x);
		diff = Y - X;
		cout << x <<"  " << diff << endl; 
	}
}
void CosCompareTest(){
	SDouble x,p = 0.1*Pi();
	int j;
	cout << "compare CosS_RN(x) and CosBS(x)" << endl;
	cout << "   x    " << "CosS_RN(x) - CosBS(x)" << endl;
	SDouble Y, X, diff;
	for(j = -10; j <= 10; j++){
		x = p*j;
		Y = CosS_RN(x);
		X = CosBS(x);
		diff = Y - X;
		printf(" %20.15f ", doubleD(x));
		cout << "diff = " << diff << endl; 
	}
}
void TanCompareTest(){
	SDouble x,p = DRand(x.Size());//0.1*Pi();
	int j;
	cout << "compare TanSN(x) and TanBS(x)" << endl;
	cout << "   x    " << "TanSN(x) - TanBS(x)" << endl;
	SDouble Y, X, diff;
	for(j = -10; j <= 10; j++){
		x = p*j;
//cout << x << endl;
		Y = TanRN(x);
		X = TanBS(x);
		diff = Y - X;
		printf(" %20.15f ", doubleD(x));
		cout << "diff = " << diff << endl; 
	}
}
void SinhTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Sinh(x)");
	SDouble X, Y;
	for(j = -10; j <= 10; j++){
		x = p*j;
		y = sinh(x);
		X = x;
		Y = Sinh(X);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void CoshTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Cosh(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = p*j;
		y = cosh(x);
		Y = Cosh(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void TanhTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Tanh(x)");
	SDouble Y;
	for(j = -10; j <= 10; j++){
		x = p*j;
		y = tanh(x);
		Y = Tanh(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void SqrtTest(){
	double x, y, z, p = 0.1;
	int j;
	ShowTitle("Sqrt(x)");
	SDouble Y;
	for(j = 1; j <= 20; j++){
		x = p*j;
		y = sqrt(x);
		Y = Sqrt(x);
		z = doubleD(Y);
		Y = Y - y;
		printf(" %20.15f  %20.15f %13.5e ", x, y, z - y);
		if(Y.Sign() >= 0) putchar(' ');
		Y.Puts(10, 5);
	}
}
void Atan2Test(){
	double x, y, z;
	int n, N = 10;
	ErrorPuts("****************** test of Atan2(n, d) ********************");
	SDouble diff, Z;
	puts("  x     y       double       test of doubleD()  difference");
	for(n = -N; n < N; n++){
		if(!n) continue;
		x = n*0.1;
		y = -n*0.3;
		z = atan2(x, y);
		Z = Atan2(x, y);
//		zd = doubleD(Z);
		diff = z - Z;
//		d = doubleD(diff);
		cout << x <<"  "<< y <<"  "<< z << "  ";
//		printf(" %3d %3d %20.15f  %13.5e  ", x, y, z - y);
		diff.Puts(10, 5);
	}
}
void ModfTest(int mpl){
	double  ip, dp, x, p = M_PI_2 * mpl;
	int n;
	ErrorPuts("****************** test of Modf(x, ip) ********************");
	SDouble iP, dP;
	puts("      x                  ip       dp      difference of ip   difference of dp");
	for(n = -10; n <= 10; n++){
		x = n*p;
		dp = modf(x, &ip);
		dP = Modf(x, iP);
		iP -= ip;
		dP -= dp;
		printf(" %20.15f %7.1f %20.15f ", x, ip, dp);
		if(iP.Sign() >= 0) { putchar(' '); }	putchar(' ');		iP.Put(10, 5); 
		if(dP.Sign() >= 0) {putchar(' '); } 	putchar(' ');		dP.Puts(10, 5); 
	}
}
void FmodTest(){
	double  f,  x, y, p = M_PI_2;
	int n, q;
	srand((unsigned)time(NULL));
	ErrorPuts("**************** test of f = Fmod(x, y, a) ***************");
	SDouble a, dF;
	puts("  x     y       f                difference of f      doubleD(a)");
	for(n = -10; n <= 10; n++){
		x = n*p;
		do{ y = (n & 1) ? (rand()%100) : -(rand()%100); } while(y == 0.0);
		y /= 100;	y *= M_SQRT_2;
		while(fabs(y) < 0.01) y *= 10.0;
		f = fmod(x, y);
		dF = Fmod(x, y, a);
		dF -= f;
		printf("%18.13f%18.13f%18.13f", x, y, f);
		putchar(' ');
		q = dF.Put(10, 5);
		f = doubleD(a);
		while(q++ < 14) putchar(' ');
		printf("%8.3f\n", f);
	}
}
void LogLargeX(){
	SDouble x, y;
	double a = 1.0e200, b;
	y = a;
	y.Puts();
	x = Log(y);
	b = log(a);
	x.Puts();
	x -= b;
	printf("a = %.15f  difference = ", b);
	x.Puts();

	y = 1.0;
	y.MultPow10(1000);
	x = Log(y);
	printf("y = "); 		y.Puts();
	printf("Log(y) = "); 	x.Puts();
}

void LLDivTest(){
	int a, b;
	int sgn = 1;
//long versin(ldiv_t, ldiv) of Turbo C++ Ver.4 is different from int version.
//Perhaps bugs.
	div_t r;
	SLong u, v;
	Ldiv_t  R;
	puts("LLDiv() test");
	puts("  a       b    quot    rem  diff. of quot   diff. of rem");
	srand((unsigned)time(NULL));
	for(a = -1000; a <= 1000 ; a+= 233){
		do{ b = sgn*rand()%100; }while(!b);
		sgn = -sgn;
		r = div(a, b);
		R = LLDiv(a, b, true);
		u = R.quot-r.quot;	v = R.rem - r.rem;
		printf("%5d  %5d %5d  %8d",a, b, r.quot, r.rem);
		printf("     ");	u.Put();	printf("     ");		v.Puts();
	}
}
void ShowCalcInfo(const SDouble& c, double cpu_time){
	printf("Up to %ldth terms, cpu time = %.3f\n",c.UpToTerm(), cpu_time);
}
void FuncXTest(SDouble (*pfunc)(const SDouble&),
SDouble& x, const char* fname){
	Timer timer;
	double cpu_time;
	SDouble r;

	fprintf(stderr, "Calculating %8s for x = %10.5f  ", fname, doubleD(x));
	timer.Start();
	r = (*pfunc)(x);
	cpu_time = timer.Stop();
	ShowCalcInfo(r, cpu_time);
}
void FuncSpeed(){
	RealSize C, D;
	SDouble x, rx, tx, mx, mtx, mrx;
	uint ef;
	double d, pi4 = M_PI/4.0;
	ErrorPuts("Speed test for long decimal number.");
	while(1){
		ErrorPut("Effective figures /4 = ? ");
		ef = GetInt();
		if(!ef) break;
		C.SetEffFig(ef);
		x = DRand();  d = doubleD(x);
		rx = x/(0.3*d);
		if(d > pi4) tx = x/pi4;
		else        tx = x;
		mx = -x; mtx = -tx; mrx = -rx;
		ErrorPuts("Calculating constants now.");
		D.SetEffFig(ef+10);
		E();	Log10();	Pi();   M2Pi();
		D.SetEffFig(0);
		printf("Figures of x = %u\n", x.Last());
		FuncXTest(SinRN, tx,"SinRN");  FuncXTest(SinRN, mtx,"SinRN");
		FuncXTest(SinDiv, tx,"SinDiv"); FuncXTest(SinDiv, mtx,"SinDiv");
		FuncXTest(CosRN, tx,"CosRN"); FuncXTest(CosRN, mtx,"CosRN");
		FuncXTest(CosDiv, tx,"CosDiv");FuncXTest(CosDiv, mtx,"CosDiv");
		FuncXTest(Sin, tx,"Sin");
		FuncXTest(Cos, tx,"Cos");
		FuncXTest(Tan, tx,"Tan");
		FuncXTest(Exp, x,"Exp");
		FuncXTest(Log, x,"Log");
		FuncXTest(LogE, x,"LogE");
		FuncXTest(Log10, x,"Log10");
		FuncXTest(Sinh, x,"Sinh");
		FuncXTest(Cosh, x,"Cosh");
		FuncXTest(Tanh, x,"Tanh");
		FuncXTest(Asin, x,"Asin");
		FuncXTest(Acos, x,"Acos");
		FuncXTest(Atan, x,"Atan"); FuncXTest(Atan, mx,"Atan");
		FuncXTest(AtanA, x,"AtanA");FuncXTest(AtanA, mx,"AtanA");
		FuncXTest(AtanT, x,"AtanT");FuncXTest(AtanT, mx,"AtanT");
		FuncXTest(Asinh, x,"Asinh");FuncXTest(Asinh, mx,"Asinh");
		FuncXTest(Acosh, rx,"Acosh");
		FuncXTest(Atanh, x,"Atanh");FuncXTest(Atanh, mx,"Atanh");
		FuncXTest(Sqrt, x,"Sqrt");
		FuncXTest(DReciprocal, x,"DReciprocal");
		C.SetEffFig(0);
		Wait();
	}
}
int main(){
	step = 2;
	ModfTest(100);     Wait();
	ExpCompareTest(1000); Wait();
	FuncSpeed();	Wait();
	AtanTest();		Wait();
	AtanATest();	Wait();
	Atan2Test();	Wait();
	CosCompareTest(); Wait();
	TanCompareTest(); Wait();
	ExpTest();		Wait();
	SinTest();  	Wait();
	CosTest();		Wait();
	TanTest();		Wait();
	LogLargeX();	Wait();
	LogTest();  	Wait();
	Log10Test();	Wait();
	FmodTest();     Wait();

	BcosTest();		Wait();
	LLDivTest();	Wait();
	CoshTest(); 	Wait();
	SinhTest(); 	Wait();
	TanhTest(); 	Wait();
	SqrtTest();		Wait();

	BsinTest();  	Wait();
	AsinTest();		Wait();
	AcosTest();		Wait();

	Ending();
	return 0;
}

