// OutFactTbl2File.cpp
// A sample program : outputs a table of factorials to a file.

#include "sn.h"

SLong DblFact(int n){ // Double factorial n!! = nx(n-2)x...
	int k = n/2;
	if(n & 1) { // n = 2k-1, n!! = (2k)!/(2^k*k!)
		k = (n + 1)/2;
#if 1
		SLong a = Fact(2*k); // a =(2k)!
		a /= Pow2(k); a /= Fact(k);// a = (2k)!/(2^k*k!)
		return a;
#else
	SFraction a(Fact(2*k), Fact(k)*Pow2(k));
	a.Reduce();
	SLong r = a.Num();
	return r;
#endif
	}else return Pow2(k)*Fact(k); // n = 2k, n!! = (2k)!! = 2^k*k!
}
int main(){
	unsigned int n, N = 100;
    cout << N << "!!=" << DblFact(N) << endl;
    cout << N+1 << "!!=" << DblFact(N+1) << endl;

	const char fname[] = "fact.res"; // file name
	cerr << "output to file : " << fname << endl;
	ofstream fout(fname, ios::out);	 // open file
	for(n = 10; n <= N; n += 10)
		fout << n << "! =" << Fact(n) << endl; // calculation of a factorial n!
	fout << "End of factorial table." << endl;
	fout.close();	// closes file
	cerr << "read from file : " << fname << endl;

	ifstream fin(fname, ios::in);
	string buff;

	while(fin && getline(fin, buff))
		cout << buff << endl;
	fin.close();
}

