/*  divaddbk.cpp  by K.Tsuru  */
/******************************************************
 SInteger and SLong test program for division
 When you made a multi-precision integer arithmetic,
 please run this program or eauivalent one.

 See 55th line in slmdivkn.cpp
*******************************************************/

#include "sn.h"
#include "timer.h"
#include "wait.h"
#include "getnum.h"
const char* const title = "This program causes \"add back\" in Knuth's division.";

void SLAddBackTest(){
	SLong a, b, c, r(10);

	ErrorPuts("SLong / SLong");
	a.UseKnuthLLDiv();

	if(a.LLDivMode()== a.Knuth) ErrorPuts("LLDivmode() is Knuth.");

	a=Lpow(r,15) -1;	// a = 10^15-1=99999 99999 99999
	b=Lpow(r,10) -1;	// b = 10^10-1=99999 99999
	r=a*b;
	a.Put(4); putchar('*'); b.Put(4); putchar('=');  r.Puts(4);
	c = r/a;
	r.Put(4); putchar('/'); a.Put(4); putchar('=');  c.Puts(4);
	r = b-c;
	r.Puts();
	Wait("b-(a*b)/a = 0?");
}
void SIAddBackTest(){
	SInteger a, b, c, r(BRADIX);

	ErrorPuts("SInteger / SInteger");
	if(a.LLDivMode()== a.Knuth) ErrorPuts("LLDivmode() is Knuth.");
	a=Ipow(r,15) -1;	// a = BRADIX^15-1=32767 32767 ..... 32767
	b=Ipow(r,10) -1;    // b = BRADIX^10-1
	r=a*b;
	puts("a=");
	a.RawPuts();
	puts("b=");
	b.RawPuts();
	puts("r=a*b=");
	r.RawPuts();
	c = r/a;
	puts("r/a=");
	c.RawPuts();
	r = b-c;
	r.Puts();
	Wait("b-(a*b)/a = 0?");
}
int main(){
	ErrorPuts(title);
	SLong t;
	t.UseKnuthLLDiv();

	SLAddBackTest();
	SIAddBackTest();
	Ending();
}
