/*  smpconst.cpp  by K.Tsuru  */
// SNumber Library sample
static const char* title ="<<<<< A sample program for constants. >>>>";

#include "sn.h"

int menu(long ef)
{
	cerr << "****************************************" << endl;
	cerr << " Effective figures = "<< ef << endl;
	cerr << "****************************************" << endl;
	cerr << " base of natural logarithm e ........1" << endl;
	cerr << " 1/e ................................2" << endl;
	cerr << " natulal rogarithm log 2 ............3" << endl;
	cerr << " natural rogarithm log 10 ...........4" << endl;
	cerr << " pi .................................5" << endl;
	cerr << " 2/pi ...............................6" << endl;
	cerr << " sqrt(pi) ...........................7" << endl;
	cerr << " sqrt(2) ............................8" << endl;
	cerr << " 1/sqrt(2) ..........................9" << endl;
	cerr << " exp(pi) ...........................10" << endl;
	cerr << " log(pi) ...........................11" << endl;
	cerr << " quit ...............................0" << endl;
	cerr << "****************************************" << endl;
	cerr << endl << "If you select 1, 4 or 5, its constant file will be created or updated" << endl;
	cerr << " in the " << SNC_DIR << "directory." << endl<< endl;

	int n;
	do{
		cerr << "select No. = ";
		n = GetInt();
	}while((n < 0) || (n > 11) );
	return n;
}

int main()
{
	int fig, m;
	Timer timer;
	double t;
	long ef;
	RealSize C;

	C.Version();
	cerr << title << endl;
	cerr << "Effective figures / "<< DFIGURES << " ? = ";
	fig =abs(GetInt());
	C.SetEffFig(fig);
	ef = (long)C.EffFigures()*DFIGURES;

	SDouble res, x(0.0);
	x.ShowMessage(ON);
	x.SetFormat(10, 0, 5, x.CRLF|x.INT_PUT|x.SHOW_FIG);
cout << "lF = " << x.lineFormat << endl;
	while(1){
		m = menu(ef);
		if(m == 0) break;
		cerr << "Calculating now." << endl;
		if(m) timer.Start();
		switch(m){
			case  1 : res = E();		break;
			case  2 : res = RecE();		break;
			case  3 : res = Log(2);		break;
			case  4 : res = Log10();	break;
			case  5 : res = Pi();		break;
			case  6 : res = M2Pi();		break;
			case  7 : res = Sqrt(Pi());	break;
			case  8 : res = Sqrt(2);	break;
			case  9 : res = RecSqrt(2);	break;
			case 10 : res = Exp(Pi());	break;
			case 11 : res = Log(Pi());	break;
		}
		t = timer.Stop();
		cout << "CPU time = " << t << "(sec)" << endl;
		cerr << "Do you want to output result ?";
		if (fig > 100000) cerr << " It maybe need much time.";
		cerr << " Yes(1)/No(0)=? ";
		if(GetInt()) res.Puts(-1);//cout << res << endl;
cout << "lF = " << x.lineFormat << endl;
		Wait();
		res = 0.0;	// memory free
	}
	Ending();
}
